<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <div
            v-if="defaultData && defaultData.cover"
        >
            <img
                :src="defaultData.cover"
                class="max-w-full"
            />
        </div>
        <auto-form
            ref="form"
            :default-data="defaultData"
            :hidden-data="{
                id: formModel.id ?? '',
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    formModel: {
        required: false,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref();
const categories = ref([]);

const defaultData = ref({});

const categorySelects = computed(() => {
    if (!categories.value) return [];
    return Object.keys(categories.value).map(key => {
        return {
            text: categories.value[key],
            value: String(key),
        };
    });
});

const formFields = computed(() => {
    return [
        {
            type: 'file',
            name: 'cover',
            label: $i18n.t('cover_image'),
            accept: 'image/*',
        },
        {
            type: 'select',
            name: 'category',
            options: categorySelects.value,
            label: $i18n.t('category'),
        },
        {
            type: 'text',
            name: 'subject',
            label: $i18n.t('subject'),
        },
        {
            type: 'text',
            name: 'description',
            label: $i18n.t('description'),
        },
        {
            type: 'editor',
            name: 'content',
            label: $i18n.t('content'),
            uploadImageUrl: '/article/upload_image_by_file',
        }
    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/article/submit_form');

        if (resp.article) {
            emit('update', resp.article);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/article/build_form', {
            id: props.formModel ? props.formModel.id : '',
        });

        if (data.article) {
            model.value = data.article;

            if (props.formModel) {
                defaultData.value = data.article;
            }
        }

        if (data.categories) {
            categories.value = data.categories;
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
